program MMClient_Delphi;

{$APPTYPE CONSOLE}

{%File 'default.txvpck'}
{%File 'ModelSupport\default.txvpck'}
//{%File 'ModelSupport\Unit1\Unit1.txvpck'}
{%File 'ModelSupport\zival\zival.txvpck'}

uses
  SysUtils,
  ScktComp,
  Classes,
  zival in 'zival.pas';

function readch(s: TStream): char;
var
  ch: char;
begin
  s.Read(ch, 1);
  readch := ch;
end;

function haveline(s: string): boolean;
begin
  if s[Length(s)] = #10 then haveline := true
  else haveline := false;
end;

procedure chopline(var s: string);
begin
  if s[Length(s)] = #10 then SetLength(s, Length(s)-1);
  if s[Length(s)] = #13 then SetLength(s, Length(s)-1);
end;

function readline(s: TStream): string;
var
  str: string;
begin
  str := '';
  repeat
    str := str + readch(s);
  until haveline(str);
  chopline(str);
  readline := str;
end;

procedure connect(hostname: string; var client: TClientSocket; var cstream: TWinSocketStream);
var
  server, succ: string;
  tip: string;
begin
  client := TClientSocket.Create(nil);

  client.Port := 1174;
  client.Host := hostname;
  client.ClientType := ctBlocking;
  cstream := TWinSocketStream.Create(client.Socket, -1);
  client.Active := true;

  server := readline(cstream);
  WriteLn(server);

  if TZival.getTip = pasmaMuca then tip := 'MACKA' else tip := 'MIS';
  client.Socket.SendText('AVE ' + tip + ' ' + TZival.getIme + #10);
  succ := readline(cstream);
  if succ <> 'PRIJAVA USPESNA' then raise Exception.Create('Napaka pri povezavi na streznik');
end;

procedure event_loop(client:TClientSocket; s: TWinSocketStream);
label adijo;
var
  cmd: string;
  cmda: TStringList;
  j, n: TKoordinate;
  js, ns: TStanje;
  z: TZival;
  Smer: Double;
  SpremembaSmeri, SpremembaHitrosti: Double;
  fmt: TFormatSettings;
begin
  GetLocaleFormatSettings(1033, fmt);
  cmda := TStringList.Create;
  cmda.Delimiter := ' ';

  while true do begin
    cmd := readline(s);
    cmda.Clear;
    cmda.DelimitedText := cmd;

    if cmda.Strings[0] = 'ADIJO' then break;
    if cmda.Strings[0] = 'KONEC_IGRE' then continue;
    if cmda.Strings[0] <> 'ZBUDI_SE' then raise Exception.Create('Napaka pri komunikaciji s streznikom');

    j.x := StrToFloat(cmda.Strings[1], fmt);
    j.y := StrToFloat(cmda.Strings[2], fmt);
    n.x := StrToFloat(cmda.Strings[3], fmt);
    n.y := StrToFloat(cmda.Strings[4], fmt);

    z := TZival.Create;
    z.ZbudiSe(j, n, Smer);
    client.Socket.SendText('BUDNA ' + FloatToStr(Smer) + #10);

    while true do begin
      cmd := readline(s);
      cmda.Clear;
      cmda.DelimitedText := cmd;

      if cmda.Strings[0] = 'ADIJO' then goto adijo;
      if cmda.Strings[0] = 'KONEC_IGRE' then begin
        z.KonecIgre(ERazlog(StrToInt(cmda.Strings[1])));
        z.Free;
        break;
      end else if cmda.Strings[0] = 'QV' then begin
        js.koordinate.x := StrToFloat(cmda.Strings[1], fmt);
        js.koordinate.y := StrToFloat(cmda.Strings[2], fmt);
        js.smer.d := StrToFloat(cmda.Strings[3], fmt);
        js.smer.v := StrToFloat(cmda.Strings[4], fmt);
        ns.koordinate.x := StrToFloat(cmda.Strings[5], fmt);
        ns.koordinate.y := StrToFloat(cmda.Strings[6], fmt);
        ns.smer.d := StrToFloat(cmda.Strings[7], fmt);
        ns.smer.v := StrToFloat(cmda.Strings[8], fmt);

        z.KamGres(js, ns, SpremembaSmeri, SpremembaHitrosti);
        client.Socket.SendText('QVR ' + FloatToStr(SpremembaSmeri) + ' ' + FloatToStr(SpremembaHitrosti) + #10);
      end;
    end;
  end;
adijo:
end;

var
  client: TClientSocket;
  cstream: TWinSocketStream;
  hostname: string;

begin
  if ParamCount() < 2 then hostname:= 'localhost'
  else hostname := ParamStr(1);

  connect(hostname, client, cstream);
  event_loop(client, cstream);
end.

