unit zival;
interface
uses TypInfo;

{ Konstante }
const MAX_SPREMEMBA_SMERI = 5 * Pi / 180;
const MAX_SPREMEMBA_HITROSTI = 0.001;
const DOSEG_LOVCA = 0.01;
const MAX_KORAKOV = 3000;

{ Pozicija zivali }
type TKoordinate = record
  x, y: Double;
end;

{ Smer zivali; d = kot v radianih, v = hitrost v 1/korak }
type TSmer = record
  d, v: Double;
end;

{ Pozicija in smer zivali }
type TStanje = record
  koordinate: TKoordinate;
  smer: TSmer;
end;

type ETip = ( pasmaNobena = 0, pasmaMuca = 1, pasmaMis = 2 );
type ERazlog = ( razlogNapaka = 0, razlogZmagala = 1, razlogZgubila = 2);

type TZival = class
  public
  const Tip: ETip = pasmaMuca;
  const Ime: string = 'Moja mucka';

  procedure ZbudiSe(jaz: TKoordinate; nasprotnik: TKoordinate; var Smer: Double);
  procedure KamGres(jaz: TStanje; nasprotnik: TStanje; var SpremembaSmeri: Double; var SpremembaHitrosti: Double);
  procedure KonecIgre(r: ERazlog);

  class function getTip(): ETip;
  class function getIme(): string;
end;

implementation

procedure TZival.ZbudiSe(jaz: TKoordinate; nasprotnik: TKoordinate; var Smer: Double);
begin
  Smer := 0.0;
end;

procedure TZival.KamGres(jaz: TStanje; nasprotnik: TStanje; var SpremembaSmeri: Double; var SpremembaHitrosti: Double);
begin
  SpremembaSmeri := 0.0;
  SpremembaHitrosti := 0.0;
end;

procedure TZival.KonecIgre(r: ERazlog);
begin
  WriteLn('Konec igre, razlog: ' + GetEnumName(TypeInfo(ERazlog), integer(r)));
end;

class function TZival.getTip() : ETip;
begin
  getTip := Tip;
end;

class function TZival.getIme(): string;
begin
  getIme := Ime;
end;
end.

